/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

struct VS_SPRITE
{
	float4 Position: POSITION0;
	float2 TexCoord: TEXCOORD0;
};


#ifdef VERTEXSHADER
#include "fxVSIncludes.fx"

VS_SPRITE SpriteVS (VS_SPRITE vs_in)
{
	VS_SPRITE vs_out;

	// billboard matrix undoes the viewangles transformation and adds a local origin transform
	// so it becomes - move position by local origin transform, then move by view origin transform.
	vs_out.Position = GetPosition (WorldMatrix, float4 (vright * vs_in.Position.x + (vup * vs_in.Position.y + entorigin), 1));
	vs_out.TexCoord = vs_in.TexCoord;

	return vs_out;
}
#endif


#ifdef PIXELSHADER
#include "fxPSIncludes.fx"

#define spriteSampler tmu0Sampler

float4 SpritePS (VS_SPRITE ps_in) : COLOR0
{
	return ApplyGammaPS (tex2D (spriteSampler, ps_in.TexCoord), 1.0f) * Alpha;
}
#endif

